SystemOrganization addCategory: #'Pier-Blog-Model'!
SystemOrganization addCategory: #'Pier-Blog-Seaside'!

!PRStructure methodsFor: '*pier-blog-model-testing' stamp: 'lr 1/15/2007 21:06'!
isBlog
	^ false! !

!PRStructure methodsFor: '*pier-blog-model-testing' stamp: 'lr 1/14/2007 13:23'!
isComment
	^ false! !

!PRStructure methodsFor: '*pier-blog-model-testing' stamp: 'lr 1/14/2007 13:44'!
isPost
	^ false! !

PRViewRenderer subclass: #PBRssRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

!PBRssRenderer methodsFor: 'visiting-document' stamp: 'lr 1/29/2007 23:31'!
visitAnchor: anObject! !

!PBRssRenderer methodsFor: 'visiting-links' stamp: 'lr 1/29/2007 23:33'!
visitInternalLinkBroken: anObject
	self visitLink: anObject! !

!PBRssRenderer methodsFor: 'visiting-links' stamp: 'lr 2/6/2007 18:47'!
visitInternalLinkGoto: anObject
	html anchor
		url: (self context structure: anObject target) url;
		with: [ self visitLink: anObject ]! !

!PBRssRenderer methodsFor: 'visiting-document' stamp: 'lr 2/5/2007 21:58'!
visitParagraph: anObject
	html paragraph: [ self visitAll: anObject children ]! !

PRRawView subclass: #PBRssView
	instanceVariableNames: 'blog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

PBRssView subclass: #PBCommentsRssView
	instanceVariableNames: 'comments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

!PBCommentsRssView class methodsFor: 'testing' stamp: 'lr 2/5/2007 19:56'!
isAbstract
	^ false! !

!PBCommentsRssView class methodsFor: 'accessing' stamp: 'lr 2/6/2007 20:00'!
label
	^ 'Comments (RSS)'! !

!PBCommentsRssView methodsFor: 'accessing' stamp: 'lr 2/5/2007 21:43'!
comments
	^ comments ifNil: [ comments := self findComments ]! !

!PBCommentsRssView methodsFor: 'private' stamp: 'lr 2/6/2007 18:26'!
findComments
	| items |
	items := self blog allCommentsIn: self context.
	^ items last: (self blog itemCount min: items size)! !

!PBCommentsRssView methodsFor: 'rendering' stamp: 'pmm 2/23/2007 09:00'!
renderComment: aComment on: rss
	| post |
	post := aComment parents reverse
		detect: [ :each | each isPost ].
	rss title: 'Comment on ' , post title.
	rss link: ((self context structure: post)
		url fragment: aComment uuid).
	aComment author
		ifNotNil: [ rss creator: aComment author ].
	rss publicationDate: (RRRfc822DateTime
		newDateAndTime: aComment publication).
	rss guid
		beNoPermaLink;
		with: aComment uuid.
	self renderDescription: aComment document on: rss! !

!PBCommentsRssView methodsFor: 'rendering' stamp: 'lr 2/5/2007 21:44'!
renderRssOn: rss
	super renderRssOn: rss.
	self comments isEmpty ifTrue: [ ^ self ].
	rss lastBuildDate: (RRRfc822DateTime
		newDateAndTime: self comments last publication).
	self comments do: [ :each |
		rss item: [ self renderComment: each on: rss ] ]! !

!PBCommentsRssView methodsFor: 'accessing-dynamic' stamp: 'lr 2/5/2007 21:46'!
title
	^ 'Comments for ' , super title! !

PBRssView subclass: #PBEntriesRssView
	instanceVariableNames: 'posts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

!PBEntriesRssView class methodsFor: 'testing' stamp: 'lr 2/5/2007 19:55'!
isAbstract
	^ false! !

!PBEntriesRssView class methodsFor: 'accessing' stamp: 'lr 2/6/2007 20:00'!
label
	^ 'Entries (RSS)'! !

!PBEntriesRssView methodsFor: 'private' stamp: 'lr 2/5/2007 19:41'!
findPosts
	| items |
	items := self blog allPostsIn: self context.
	^ items last: (self blog itemCount min: items size)! !

!PBEntriesRssView methodsFor: 'accessing' stamp: 'lr 2/5/2007 21:42'!
posts
	^ posts ifNil: [ posts := self findPosts ]! !

!PBEntriesRssView methodsFor: 'rendering' stamp: 'lr 3/12/2007 20:15'!
renderPost: aPost on: rss
	rss title: aPost title.
	rss link: (self context structure: aPost) url.
	rss comments: (self context structure: aPost) url.
	rss commentRss: (self context
		structure: self blog
		view: PBCommentsRssView) url.
	rss publicationDate: (RRRfc822DateTime
		newDateAndTime: aPost publication).
	aPost tags
		do: [ :each | rss category: each ].
	self renderDescription: aPost document on: rss.
	aPost author
		ifNotNil: [ rss creator: aPost author ].
	rss guid
		beNoPermaLink;
		with: aPost uuid.
	aPost enclosure ifNotNilDo: [ :value |
		rss enclosure
			url: (value file urlOn: rss);
			length: value file filesize;
			type: value file mimetype ].
	aPost sourceUrl ifNotNil: [
		rss source
			url: aPost sourceUrl;
			with: aPost sourceTitle ]! !

!PBEntriesRssView methodsFor: 'rendering' stamp: 'lr 2/5/2007 21:42'!
renderRssOn: rss
	super renderRssOn: rss.
	self posts isEmpty ifTrue: [ ^ self ].
	rss lastBuildDate: (RRRfc822DateTime
		newDateAndTime: self posts last publication).
	self posts do: [ :each |
		rss item: [ self renderPost: each on: rss ] ]! !

!PBRssView class methodsFor: 'testing' stamp: 'lr 2/5/2007 19:55'!
isAbstract
	^ true! !

!PBRssView class methodsFor: 'testing' stamp: 'lr 2/6/2007 18:23'!
isValidIn: aContext
	^ (super isValidIn: aContext) and: [ aContext structure isBlog ]! !

!PBRssView class methodsFor: 'accessing' stamp: 'lr 2/6/2007 20:00'!
label
	^ 'Deprecated (RSS)'! !

!PBRssView class methodsFor: 'instance-creation' stamp: 'lr 2/12/2007 19:07'!
new
	"This is an ugly hack to make already bookmarked blogs work properly."

	^ self name = #PBRssView
		ifTrue: [ PBEntriesRssView new ]
		ifFalse: [ super new ]! !

!PBRssView methodsFor: 'accessing' stamp: 'lr 2/5/2007 19:39'!
blog
	^ blog ifNil: [ blog := self find: PBBlog ]! !

!PBRssView methodsFor: 'accessing-dynamic' stamp: 'lr 2/5/2007 21:35'!
link
	^ (self context structure: self blog) url! !

!PBRssView methodsFor: 'rendering' stamp: 'lr 5/22/2007 23:09'!
renderDescription: aDocument on: rss
	| html |
	rss description: [ rss cdata: (PRTextWriter write: aDocument) ].
	rss contentEncoded with: [
		rss html: '<!![CDATA['.
		html := WARenderCanvas
			context: rss context
			callbacks: Dictionary new.
		PBRssRenderer new
			start: aDocument
			in: self on: html.
		html flush.
		rss html: ']]>' ]! !

!PBRssView methodsFor: 'rendering' stamp: 'lr 9/13/2007 22:24'!
renderRssOn: rss
	"Generate some standard information that should be present in all the feeds."

	rss title: self title; link: self link.
	self renderDescription: self blog document on: rss.
	rss generator: 'Pier Blog'.
	rss language: self blog language.
	self blog tags do: [ :each | rss category: each ].
	self blog copyright
		ifNotNil: [ rss copyright: self blog copyright ].
	self blog managingEditor
		ifNotNil: [ rss managingEditor: self blog managingEditor ].
	self blog webMaster
		ifNotNil: [ rss webMaster: self blog webMaster ]! !

!PBRssView methodsFor: 'processing' stamp: 'pmm 4/12/2007 20:36'!
renderWithContext: aContext
	| response document root |
	response := WAResponse new contentType: RRRssRoot defaultContentType.
	root := RRRssRoot new.
	document := WAHtmlStreamDocument new.
	document stream: response stream.
	document open: root.
	[ self renderRssOn: (RRRssRenderCanvas
		context: (aContext document: document)
		callbacks: Dictionary new) ]
		on: Error do: [ :err | response := WAResponse internalError: err ].
	document close: root.
	self session expire; returnResponse: response! !

!PBRssView methodsFor: 'accessing-dynamic' stamp: 'lr 2/5/2007 21:25'!
title
	^ self blog feedTitle ifNil: [ self blog title ]! !

!PRVisitor methodsFor: '*pier-blog-model' stamp: 'lr 1/15/2007 21:51'!
visitBlog: anObject
	self visitCase: anObject! !

!PRVisitor methodsFor: '*pier-blog-model' stamp: 'lr 1/15/2007 21:11'!
visitComment: anObject
	self visitEntry: anObject! !

!PRVisitor methodsFor: '*pier-blog-model' stamp: 'lr 1/15/2007 21:51'!
visitEntry: anObject
	self visitCase: anObject! !

!PRVisitor methodsFor: '*pier-blog-model' stamp: 'lr 1/15/2007 16:08'!
visitPost: anObject
	self visitEntry: anObject! !

PRWidget subclass: #PBPostFilter
	instanceVariableNames: 'blog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

PBPostFilter subclass: #PBPostArchive
	instanceVariableNames: 'archive'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

!PBPostArchive class methodsFor: 'testing' stamp: 'lr 11/6/2007 17:54'!
isAbstract
	^ false! !

!PBPostArchive class methodsFor: 'accessing' stamp: 'lr 11/6/2007 18:07'!
label
	^ 'Post Archive'! !

!PBPostArchive methodsFor: 'accessing' stamp: 'lr 11/6/2007 19:08'!
archive
	^ archive ifNil: [ archive := self buildArchive ]! !

!PBPostArchive methodsFor: 'private' stamp: 'lr 11/6/2007 19:15'!
buildArchive
	| monthMap monthSorted |
	monthMap := Dictionary new.
	self posts do: [ :each |
		(monthMap at: each publication asMonth ifAbsentPut: [ OrderedCollection new ])
			add: each ].
	monthSorted := SortedCollection 
		sortBlock: [ :a :b | a key > b key ].
	monthMap associationsDo: [ :assoc | monthSorted add: assoc ].
	self maxItems notNil
		ifTrue: [ monthSorted := monthSorted first: (monthMap size min: self maxItems) ].
	^ monthSorted! !

!PBPostArchive methodsFor: 'actions' stamp: 'lr 11/6/2007 19:08'!
refresh
	super refresh.
	archive := nil! !

!PBPostArchive methodsFor: 'rendering' stamp: 'lr 11/6/2007 19:15'!
renderBlogOn: html
	self archive isEmpty ifTrue: [ ^ self ].
	html unorderedList: [
		self archive do: [ :assoc |
			html listItem: [
				self 
					renderFilter: assoc value
					with: assoc key name , ' ' , assoc key year asString
					on: html ] ] ]! !

!PBPostFilter class methodsFor: 'accessing-descriptions' stamp: 'lr 11/6/2007 18:25'!
descriptionMaxItems
	^ MANumberDescription new
		selectorAccessor: #maxItems;
		addCondition: [ :value | value isInteger and: [ value positive ] ]
			labelled: 'Positive integer expected.';
		comment: 'The maximum number of items to show.';
		label: 'Max Items';
		priority: 200;
		default: 10;
		yourself! !

!PBPostFilter class methodsFor: 'accessing-descriptions' stamp: 'lr 11/6/2007 19:04'!
descriptionShowCount
	^ MABooleanDescription new
		selectorAccessor: #showCount;
		label: 'Show Count';
		default: true;
		priority: 210;
		yourself! !

!PBPostFilter methodsFor: 'accessing' stamp: 'lr 11/6/2007 18:16'!
blog
	"Answer the currently browsed blog or nil."
	
	^ blog ifNil: [ blog := self findBlog ]! !

!PBPostFilter methodsFor: 'actions' stamp: 'lr 11/6/2007 18:56'!
filter: aCollection
	| newContext |
	newContext := self context structure: self blog.
	newContext command viewComponent posts: aCollection.
	self context: newContext! !

!PBPostFilter methodsFor: 'private' stamp: 'lr 11/6/2007 18:16'!
findBlog
	^ self context structure parents reverse
		detect: [ :each | each isKindOf: PBBlog ]
		ifNone: [ nil ]! !

!PBPostFilter methodsFor: 'accessing-settings' stamp: 'lr 11/6/2007 18:25'!
maxItems
	^ self read: #descriptionMaxItems! !

!PBPostFilter methodsFor: 'events' stamp: 'lr 11/6/2007 19:01'!
onChangeContext: aContext
	super onChangeContext: aContext.
	self blog = self findBlog
		ifFalse: [ self refresh ]! !

!PBPostFilter methodsFor: 'accessing' stamp: 'lr 11/6/2007 18:12'!
posts
	"Answer the currently displayed blog posts."
	
	^ self blog allPostsIn: self context! !

!PBPostFilter methodsFor: 'actions' stamp: 'lr 11/6/2007 19:02'!
refresh
	blog := nil! !

!PBPostFilter methodsFor: 'rendering' stamp: 'lr 11/6/2007 18:14'!
renderBlogOn: html
	self subclassResponsibility! !

!PBPostFilter methodsFor: 'rendering' stamp: 'lr 11/6/2007 18:45'!
renderContentOn: html
	self blog isNil
		ifTrue: [ html text: '(no blog found)' ]
		ifFalse: [ self renderBlogOn: html ]! !

!PBPostFilter methodsFor: 'rendering' stamp: 'lr 11/6/2007 18:58'!
renderFilter: aCollection with: aRenderBlock on: html
	html anchor
		callback: [ self filter: aCollection ];
		with: aRenderBlock.
	self showCount
		ifTrue: [ html text: ' ('; render: aCollection size; text: ')' ]! !

!PBPostFilter methodsFor: 'accessing-settings' stamp: 'lr 11/6/2007 18:26'!
showCount
	^ self read: #descriptionShowCount! !

PBPostFilter subclass: #PBPostTags
	instanceVariableNames: 'tags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

!PBPostTags class methodsFor: 'testing' stamp: 'lr 11/6/2007 17:55'!
isAbstract
	^ false! !

!PBPostTags class methodsFor: 'accessing' stamp: 'lr 11/6/2007 17:55'!
label
	^ 'Post Tags'! !

!PBPostTags methodsFor: 'private' stamp: 'lr 11/6/2007 18:53'!
findTags
	| tagsMap tagsByCount |
	tagsMap := Dictionary new.
	self posts do: [ :post |
		post tags do: [ :tag |
			(tagsMap at: tag ifAbsentPut: [ OrderedCollection new ])
				add: post ] ].
	tagsByCount := SortedCollection
		sortBlock: [ :a :b | a value size < b value size ].
	tagsMap associationsDo: [ :assoc | tagsByCount add: assoc ].
	self maxItems notNil
		ifTrue: [ tagsByCount := tagsByCount last: (tagsByCount size min: self maxItems) ].
	^ tagsByCount asSortedCollection: [ :a :b | a key < b key ]! !

!PBPostTags methodsFor: 'actions' stamp: 'lr 11/6/2007 19:00'!
refresh
	super refresh.
	tags := nil! !

!PBPostTags methodsFor: 'rendering' stamp: 'lr 11/6/2007 18:35'!
renderBlogOn: html
	self tags isEmpty ifTrue: [ ^ self ].
	html unorderedList: [
		self tags do: [ :assoc |
			html listItem: [
				self 
					renderFilter: assoc value
					with: assoc key
					on: html ] ] ]! !

!PBPostTags methodsFor: 'accessing' stamp: 'lr 11/6/2007 18:10'!
tags
	^ tags ifNil: [ tags := self findTags ]! !

PRWidget subclass: #PBPostTicker
	instanceVariableNames: 'posts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

!PBPostTicker class methodsFor: 'accessing-description' stamp: 'lr 10/8/2007 16:01'!
descriptionBlog
	^ PRStructureDescription new
		selectorAccessor: #blog;
		label: 'Source';
		priority: 100;
		addCondition: [ :value | value isBlog ]
			labelled: 'Select a blog as source';
		yourself! !

!PBPostTicker class methodsFor: 'accessing-description' stamp: 'lr 11/6/2007 17:53'!
descriptionNumberOfCharacters
	^ MANumberDescription new
		selectorAccessor: #numberOfCharacters;
		addCondition: [ :value | value isInteger and: [ value positive ] ]
			labelled: 'Positive integer expected.';
		comment: 'The maximum number of characters to display of a post.';
		label: 'Number of Characters';
		priority: 110;
		default: 200;
		yourself! !

!PBPostTicker class methodsFor: 'accessing-description' stamp: 'lr 11/6/2007 17:54'!
descriptionNumberOfPosts
	^ MANumberDescription new
		selectorAccessor: #numberOfPosts;
		addCondition: [ :value | value isInteger and: [ value positive ] ]
			labelled: 'Positive integer expected.';
		comment: 'The maximum number of posts to appear.';
		label: 'Number of Posts';
		priority: 120;
		default: 3;
		yourself! !

!PBPostTicker class methodsFor: 'testing' stamp: 'lr 2/7/2007 14:32'!
isAbstract
	^ false! !

!PBPostTicker class methodsFor: 'accessing' stamp: 'lr 2/7/2007 20:36'!
label
	^ 'Post Ticker'! !

!PBPostTicker methodsFor: 'accessing' stamp: 'tg 11/8/2007 16:32'!
blog
	^ self read: #descriptionBlog! !

!PBPostTicker methodsFor: 'private' stamp: 'lr 2/7/2007 11:53'!
findPosts
	| items |
	items := self blog allPostsIn: self context.
	self numberOfPosts isNil
		ifFalse: [ items := items last: (self numberOfPosts min: items size) ].
	^ items reversed! !

!PBPostTicker methodsFor: 'accessing' stamp: 'lr 4/18/2007 15:02'!
numberOfCharacters
	^ self read: #descriptionNumberOfCharacters! !

!PBPostTicker methodsFor: 'accessing' stamp: 'lr 4/18/2007 15:02'!
numberOfPosts
	^ self read: #descriptionNumberOfPosts! !

!PBPostTicker methodsFor: 'accessing' stamp: 'lr 4/18/2007 15:03'!
posts
	^ posts ifNil: [ posts := self findPosts ]! !

!PBPostTicker methodsFor: 'rendering' stamp: 'lr 4/5/2007 17:59'!
renderContentOn: html
	self blog isNil
		ifTrue: [ ^ html div: '(no blog specified)' ].
	self posts isEmpty
		ifTrue: [ ^ html div: '(no posts available)' ].
	html unorderedList class: 'postticker'; with: [
		self posts do: [ :each |
			html listItem: [
				self renderPost: each on: html ] ] ]! !

!PBPostTicker methodsFor: 'rendering' stamp: 'lr 4/5/2007 17:59'!
renderPost: aPost on: html
	html anchor
		goto: (self context structure: aPost);
		with: aPost title.
	html div
		class: 'summary';
		with: (self summaryOf: aPost)! !

!PBPostTicker methodsFor: 'private' stamp: 'lr 9/13/2007 10:15'!
summaryOf: aPost
	| input output |
	input := aPost plainText readStream.
	output := WriteStream on: String new.
	[ input atEnd ] whileFalse: [
		output nextPutAll: (input upTo: $<).
		input upTo: $> ].
	self numberOfCharacters ifNotNil: [
		output position: (output size min: self numberOfCharacters).
		output atEnd
			ifFalse: [ output nextPutAll: '...' ] ].
	^ output contents! !

PRWidget subclass: #PBRssLinkWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

!PBRssLinkWidget class methodsFor: 'as yet unclassified' stamp: 'tg 11/8/2007 16:33'!
descriptionBlog
	^ PRStructureDescription new
		selectorAccessor: #blog;
		label: 'Source';
		priority: 100;
		addCondition: [ :value | value isBlog ]
			labelled: 'Select a blog as source';
		yourself! !

!PBRssLinkWidget class methodsFor: 'as yet unclassified' stamp: 'tg 11/8/2007 16:33'!
isAbstract
	^false! !

!PBRssLinkWidget class methodsFor: 'as yet unclassified' stamp: 'tg 11/8/2007 16:33'!
label
	^ 'RSS Link'! !

!PBRssLinkWidget methodsFor: 'accessing' stamp: 'tg 11/8/2007 16:33'!
blog
	^ self read: #descriptionBlog! !

!PBRssLinkWidget methodsFor: 'rendering' stamp: 'tg 11/8/2007 21:13'!
renderContentOn: html
	self blog isNil ifTrue: [ ^ html div: '(no blog specified)' ].
	html anchor 
		url: (self context
			structure: self blog
			view: PBEntriesRssView)
				url;
		with: [html span class: 'rsslink'; with: 'RSS']! !

PRCase subclass: #PBBlog
	instanceVariableNames: 'managingEditor webMaster copyright language itemCount feedTitle commentTimeout'
	classVariableNames: 'Languages'
	poolDictionaries: ''
	category: 'Pier-Blog-Model'!

!PBBlog class methodsFor: 'private' stamp: 'lr 1/26/2007 00:48'!
buildLanguages
	^ Dictionary new
		at: 'af' put: 'Afrikaans';
		at: 'sq' put: 'Albanian';
		at: 'eu' put: 'Basque';
		at: 'be' put: 'Belarusian';
		at: 'bg' put: 'Bulgarian';
		at: 'ca' put: 'Catalan';
		at: 'zh-cn' put: 'Chinese (Simplified)';
		at: 'zh-tw' put: 'Chinese (Traditional)';
		at: 'hr' put: 'Croatian';
		at: 'cs' put: 'Czech';
		at: 'da' put: 'Danish';
		at: 'nl' put: 'Dutch';
		at: 'nl-be' put: 'Dutch (Belgium)';
		at: 'nl-nl' put: 'Dutch (Netherlands)';
		at: 'en' put: 'English';
		at: 'en-au' put: 'English (Australia)';
		at: 'en-bz' put: 'English (Belize)';
		at: 'en-ca' put: 'English (Canada)';
		at: 'en-ie' put: 'English (Ireland)';
		at: 'en-jm' put: 'English (Jamaica)';
		at: 'en-nz' put: 'English (New Zealand)';
		at: 'en-ph' put: 'English (Phillipines)';
		at: 'en-za' put: 'English (South Africa)';
		at: 'en-tt' put: 'English (Trinidad)';
		at: 'en-gb' put: 'English (United Kingdom)';
		at: 'en-us' put: 'English (United States)';
		at: 'en-zw' put: 'English (Zimbabwe)';
		at: 'et' put: 'Estonian';
		at: 'fo' put: 'Faeroese';
		at: 'fi' put: 'Finnish';
		at: 'fr' put: 'French';
		at: 'fr-be' put: 'French (Belgium)';
		at: 'fr-ca' put: 'French (Canada)';
		at: 'fr-fr' put: 'French (France)';
		at: 'fr-lu' put: 'French (Luxembourg)';
		at: 'fr-mc' put: 'French (Monaco)';
		at: 'fr-ch' put: 'French (Switzerland)';
		at: 'gl' put: 'Galician';
		at: 'gd' put: 'Gaelic';
		at: 'de' put: 'German';
		at: 'de-at' put: 'German (Austria)';
		at: 'de-de' put: 'German (Germany)';
		at: 'de-li' put: 'German (Liechtenstein)';
		at: 'de-lu' put: 'German (Luxembourg)';
		at: 'de-ch' put: 'German (Switzerland)';
		at: 'el' put: 'Greek';
		at: 'haw' put: 'Hawaiian';
		at: 'hu' put: 'Hungarian';
		at: 'is' put: 'Icelandic';
		at: 'in' put: 'Indonesian';
		at: 'ga' put: 'Irish';
		at: 'it' put: 'Italian';
		at: 'it-it' put: 'Italian (Italy)';
		at: 'it-ch' put: 'Italian (Switzerland)';
		at: 'ja' put: 'Japanese';
		at: 'ko' put: 'Korean';
		at: 'mk' put: 'Macedonian';
		at: 'no' put: 'Norwegian';
		at: 'pl' put: 'Polish';
		at: 'pt' put: 'Portuguese';
		at: 'pt-br' put: 'Portuguese (Brazil)';
		at: 'pt-pt' put: 'Portuguese (Portugal)';
		at: 'ro' put: 'Romanian';
		at: 'ro-mo' put: 'Romanian (Moldova)';
		at: 'ro-ro' put: 'Romanian (Romania)';
		at: 'ru' put: 'Russian';
		at: 'ru-mo' put: 'Russian (Moldova)';
		at: 'ru-ru' put: 'Russian (Russia)';
		at: 'sr' put: 'Serbian';
		at: 'sk' put: 'Slovak';
		at: 'sl' put: 'Slovenian';
		at: 'es' put: 'Spanish';
		at: 'es-ar' put: 'Spanish (Argentina)';
		at: 'es-bo' put: 'Spanish (Bolivia)';
		at: 'es-cl' put: 'Spanish (Chile)';
		at: 'es-co' put: 'Spanish (Colombia)';
		at: 'es-cr' put: 'Spanish (Costa Rica)';
		at: 'es-do' put: 'Spanish (Dominican Republic)';
		at: 'es-ec' put: 'Spanish (Ecuador)';
		at: 'es-sv' put: 'Spanish (El Salvador)';
		at: 'es-gt' put: 'Spanish (Guatemala)';
		at: 'es-hn' put: 'Spanish (Honduras)';
		at: 'es-mx' put: 'Spanish (Mexico)';
		at: 'es-ni' put: 'Spanish (Nicaragua)';
		at: 'es-pa' put: 'Spanish (Panama)';
		at: 'es-py' put: 'Spanish (Paraguay)';
		at: 'es-pe' put: 'Spanish (Peru)';
		at: 'es-pr' put: 'Spanish (Puerto Rico)';
		at: 'es-es' put: 'Spanish (Spain)';
		at: 'es-uy' put: 'Spanish (Uruguay)';
		at: 'es-ve' put: 'Spanish (Venezuela)';
		at: 'sv' put: 'Swedish';
		at: 'sv-fi' put: 'Swedish (Finland)';
		at: 'sv-se' put: 'Swedish (Sweden)';
		at: 'tr' put: 'Turkish';
		at: 'uk' put: 'Ukranian';
		yourself! !

!PBBlog class methodsFor: 'testing' stamp: 'lr 1/15/2007 22:02'!
canBeParentOf: aClass
	^ aClass includesBehavior: PBPost! !

!PBBlog class methodsFor: 'accessing-description' stamp: 'lr 4/18/2007 22:55'!
descriptionCommentTimeout
	^ MADurationDescription new
		selectorAccessor: #commentTimeout;
		label: 'Comment Timeout';
		priority: 370;
		comment: 'How long should it be possible to post comments.';
		beRequired;
		beEditable;
		yourself! !

!PBBlog class methodsFor: 'accessing-description' stamp: 'lr 4/18/2007 22:55'!
descriptionCopyright
	^ MAStringDescription new
		selectorAccessor: #copyright;
		label: 'Copyright';
		priority: 350;
		comment: 'Copyright notice for content in the channel.';
		beEditable;
		yourself! !

!PBBlog class methodsFor: 'accessing-description' stamp: 'lr 10/18/2007 17:34'!
descriptionDocument
	^ super descriptionDocument
		label: 'Description';
		yourself! !

!PBBlog class methodsFor: 'accessing-description' stamp: 'lr 4/18/2007 22:55'!
descriptionFeedTitle
	^ MAStringDescription new
		selectorAccessor: #feedTitle;
		label: 'Feed Title';
		priority: 310;
		comment: 'The title of the channel.';
		beEditable;
		yourself! !

!PBBlog class methodsFor: 'accessing-description' stamp: 'lr 4/18/2007 22:56'!
descriptionItemCount
	^ MANumberDescription new
		selectorAccessor: #itemCount;
		label: 'Item Count';
		priority: 370;
		comment: 'The number of items to appear in the feed.';
		addCondition: [ :value | value isInteger and: [ value positive ] ]
			labelled: 'Positive integer expected.';
		beRequired;
		beEditable;
		yourself! !

!PBBlog class methodsFor: 'accessing-description' stamp: 'lr 4/18/2007 22:56'!
descriptionLanguage
	^ MASingleOptionDescription new
		selectorAccessor: #language;
		label: 'Language';
		priority: 360;
		comment: 'The language the channel is written in.';
		reference: (MAStringDescription new
			stringWriter: self;
			yourself);
		options: self languages keys;
		default: 'en';
		beRequired;
		beEditable;
		beSorted;
		yourself! !

!PBBlog class methodsFor: 'accessing-description' stamp: 'lr 4/18/2007 22:56'!
descriptionManagingEditor
	^ MAStringDescription new
		selectorAccessor: #managingEditor;
		label: 'Managing Editor';
		priority: 330;
		comment: 'Email address for person responsible for editorial content.';
		beEditable;
		yourself! !

!PBBlog class methodsFor: 'accessing-description' stamp: 'lr 4/18/2007 22:56'!
descriptionWebMaster
	^ MAStringDescription new
		selectorAccessor: #webMaster;
		label: 'Web Master';
		priority: 340;
		comment: 'Email address for person responsible for technical issues relating to channel.';
		beEditable;
		yourself! !

!PBBlog class methodsFor: 'testing' stamp: 'lr 1/15/2007 22:02'!
isAbstract
	^ false! !

!PBBlog class methodsFor: 'accessing-resources' stamp: 'lr 1/26/2007 00:48'!
languages
	^ Languages ifNil: [ Languages := self buildLanguages ]! !

!PBBlog class methodsFor: 'private' stamp: 'lr 1/26/2007 00:47'!
write: anObject description: aDescription
	^ self languages at: anObject ifAbsent: [ anObject ]! !

!PBBlog methodsFor: 'visiting' stamp: 'lr 1/15/2007 20:05'!
accept: aVisitor
	aVisitor visitBlog: self! !

!PBBlog methodsFor: 'accessing-dynamic' stamp: 'lr 9/24/2007 19:18'!
allCommentsIn: aContext
	"Answer all the comments in choronological order."

	^ ((aContext enumeratorFor: self) all
		select: [ :each |
			each isComment
				and: [ each publication notNil
				and: [ each publication <= TimeStamp now ] ] ])
		sort: [ :a :b | a publication < b publication ];
		yourself! !

!PBBlog methodsFor: 'accessing-dynamic' stamp: 'lr 9/24/2007 19:18'!
allPostsIn: aContext
	"Answer all the published posts in choronological order."

	^ ((aContext enumeratorFor: self)
		select: [ :each |
			each isPost
				and: [ each publication notNil
				and: [ each publication <= TimeStamp now ] ] ])
		sort: [ :a :b | a publication < b publication ];
		yourself! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 2/20/2007 15:23'!
commentTimeout
	^ commentTimeout ifNil: [ commentTimeout := 14 days ]! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 2/6/2007 19:45'!
commentTimeout: aDuration
	commentTimeout := aDuration! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 1/19/2007 19:18'!
copyright
	^ copyright! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 1/19/2007 19:18'!
copyright: aString
	copyright := aString! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 2/1/2007 19:45'!
feedTitle
	^ feedTitle! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 2/1/2007 19:41'!
feedTitle: aString
	feedTitle := aString! !

!PBBlog methodsFor: 'testing' stamp: 'lr 1/15/2007 21:06'!
isBlog
	^ true! !

!PBBlog methodsFor: '*pier-blog-seaside' stamp: 'lr 1/29/2007 13:50'!
isValidView: aComponentClass in: aContext
	^ super viewComponentClass ~= aComponentClass! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 2/1/2007 19:40'!
itemCount
	^ itemCount ifNil: [ itemCount := 10 ]! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 2/1/2007 19:41'!
itemCount: anInteger
	itemCount := anInteger! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 1/26/2007 00:33'!
language
	^ language! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 1/26/2007 00:54'!
language: aString
	language := aString! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 1/18/2007 00:16'!
managingEditor
	^ managingEditor! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 1/18/2007 00:17'!
managingEditor: anEditor
	managingEditor := anEditor! !

!PBBlog methodsFor: '*pier-blog-seaside' stamp: 'lr 2/5/2007 19:38'!
viewComponentClass
	^ PBBlogHtmlView! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 1/18/2007 00:17'!
webMaster
	^ webMaster! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 1/18/2007 00:17'!
webMaster: aString
	webMaster := aString! !

PRCase subclass: #PBEntry
	instanceVariableNames: 'uuid author publication'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Model'!

PBEntry subclass: #PBComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Model'!

!PBComment class methodsFor: 'testing' stamp: 'lr 1/15/2007 20:04'!
canBeChildOf: aClass
	^ aClass includesBehavior: PBPost! !

!PBComment class methodsFor: 'testing' stamp: 'lr 1/15/2007 20:04'!
canBeParentOf: aClass
	^ false! !

!PBComment class methodsFor: 'accessing-descriptions' stamp: 'lr 2/12/2007 19:07'!
descriptionAuthor
	^ super descriptionAuthor
		propertyAt: #public put: true;
		beRequired;
		yourself! !

!PBComment class methodsFor: 'accessing-descriptions' stamp: 'lr 10/8/2007 16:01'!
descriptionConfirmation
	^ MABooleanDescription new
		selectorAccessor: #confirmation;
		label: 'Confirmation';
		checkboxLabel: 'Confirm submission by clicking the checkbox';
		addCondition: [ :value | value = true ]
			labelled: 'Please, confirm submission by clicking the checkbox';
		propertyAt: #public put: true;
		priority: 600;
		beEditable;
		yourself! !

!PBComment class methodsFor: 'accessing-descriptions' stamp: 'lr 10/18/2007 17:34'!
descriptionDocument
	^ super descriptionDocument
		propertyAt: #public put: true;
		beRequired;
		yourself! !

!PBComment methodsFor: 'visiting' stamp: 'lr 1/15/2007 16:08'!
accept: aVisitor
	aVisitor visitComment: self! !

!PBComment methodsFor: 'private' stamp: 'lr 5/22/2007 22:47'!
confirmation
	^ false! !

!PBComment methodsFor: 'private' stamp: 'lr 5/22/2007 22:47'!
confirmation: aBoolean! !

!PBComment methodsFor: 'initialization' stamp: 'lr 2/6/2007 20:14'!
initialize
	super initialize.
	self publication: TimeStamp now! !

!PBComment methodsFor: 'testing' stamp: 'lr 1/14/2007 13:23'!
isComment
	^ true! !

!PBEntry class methodsFor: 'accessing-descriptions' stamp: 'lr 4/18/2007 22:56'!
descriptionAuthor
	^ MAStringDescription new
		selectorAccessor: #author;
		label: 'Author';
		priority: 300;
		comment: 'The author of the entry.';
		beEditable;
		yourself! !

!PBEntry class methodsFor: 'accessing-descriptions' stamp: 'lr 4/18/2007 22:57'!
descriptionPublication
	^ MATimeStampDescription new
		selectorAccessor: #publication;
		label: 'Publication';
		priority: 310;
		comment: 'The publication date of the entry.';
		beEditable;
		yourself! !

!PBEntry class methodsFor: 'testing' stamp: 'lr 1/14/2007 12:36'!
isAbstract
	^ self name = #PBEntry! !

!PBEntry methodsFor: 'visiting' stamp: 'pmm 1/26/2007 23:34'!
accept: aVisitor
	aVisitor visitEntry: self! !

!PBEntry methodsFor: 'accessing-dynamic' stamp: 'lr 9/24/2007 19:19'!
allCommentsIn: aContext
	"Answer all the published comments in choronological order."

	^ ((aContext enumeratorFor: self) all
		select: [ :each |
			each isComment
				and: [ each publication notNil
				and: [ each publication <= TimeStamp now ] ] ])
		sort: [ :a :b | a publication < b publication ];
		yourself! !

!PBEntry methodsFor: 'accessing' stamp: 'lr 1/26/2007 01:00'!
author
	^ author! !

!PBEntry methodsFor: 'accessing' stamp: 'lr 1/14/2007 12:36'!
author: aString
	author := aString! !

!PBEntry methodsFor: 'copying' stamp: 'lr 8/17/2007 08:03'!
postCopy
	super postCopy.
	uuid := nil! !

!PBEntry methodsFor: 'accessing' stamp: 'lr 1/19/2007 18:40'!
publication
	^ publication! !

!PBEntry methodsFor: 'accessing' stamp: 'lr 1/19/2007 18:40'!
publication: aTimeStamp
	publication := aTimeStamp! !

!PBEntry methodsFor: 'accessing' stamp: 'lr 2/6/2007 20:20'!
uuid
	^ uuid ifNil: [ uuid := SmallInteger maxVal atRandom asString ]! !

!PBEntry methodsFor: 'accessing' stamp: 'lr 2/6/2007 20:12'!
uuid: anObject
	uuid := anObject! !

PBEntry subclass: #PBPost
	instanceVariableNames: 'sourceUrl sourceTitle enclosure'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Model'!

!PBPost class methodsFor: 'testing' stamp: 'lr 1/15/2007 22:02'!
canBeChildOf: aClass
	^ aClass includesBehavior: PBBlog! !

!PBPost class methodsFor: 'accessing-descriptions' stamp: 'lr 10/8/2007 16:01'!
descriptionEnclosure
	^ PRStructureDescription new
		selectorAccessor: #enclosure;
		label: 'Enclosure';
		priority: 350;
		addCondition: [ :value | value isFile ]
			labelled: 'Enclosure must be a file';
		comment: 'A media object that is attached to the item.';
		beEditable;
		yourself! !

!PBPost class methodsFor: 'accessing-descriptions' stamp: 'lr 4/18/2007 22:57'!
descriptionSourceTitle
	^ MAStringDescription new
		selectorAccessor: #sourceTitle;
		label: 'Source Title';
		priority: 330;
		comment: 'The title of the RSS channel that the item came from.';
		beEditable;
		yourself! !

!PBPost class methodsFor: 'accessing-descriptions' stamp: 'lr 4/18/2007 22:57'!
descriptionSourceUrl
	^ MAStringDescription new
		selectorAccessor: #sourceUrl;
		label: 'Source URL';
		priority: 340;
		comment: 'The url of the RSS channel that the item came from.';
		beEditable;
		yourself! !

!PBPost methodsFor: 'visiting' stamp: 'lr 1/15/2007 16:08'!
accept: aVisitor
	aVisitor visitPost: self! !

!PBPost methodsFor: 'accessing' stamp: 'lr 1/27/2007 18:30'!
enclosure
	^ enclosure! !

!PBPost methodsFor: 'accessing' stamp: 'lr 2/12/2007 19:07'!
enclosure: aFile
	enclosure := aFile! !

!PBPost methodsFor: 'testing' stamp: 'lr 1/14/2007 13:44'!
isPost
	^ true! !

!PBPost methodsFor: '*pier-blog-seaside' stamp: 'lr 1/29/2007 13:50'!
isValidView: aComponentClass in: aContext
	^ super viewComponentClass ~= aComponentClass! !

!PBPost methodsFor: 'accessing' stamp: 'pmm 1/26/2007 18:07'!
sourceTitle
	^sourceTitle! !

!PBPost methodsFor: 'accessing' stamp: 'lr 2/12/2007 19:07'!
sourceTitle: aString
	sourceTitle := aString! !

!PBPost methodsFor: 'accessing' stamp: 'pmm 1/26/2007 18:07'!
sourceUrl
	^sourceUrl! !

!PBPost methodsFor: 'accessing' stamp: 'lr 2/12/2007 19:07'!
sourceUrl: aString
	sourceUrl := aString! !

!PBPost methodsFor: '*pier-blog-seaside' stamp: 'lr 2/5/2007 19:38'!
viewComponentClass
	^ PBPostHtmlView! !

PRDefaultView subclass: #PBHtmlView
	instanceVariableNames: 'blog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

PBHtmlView subclass: #PBBlogHtmlView
	instanceVariableNames: 'posts batcher'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

!PBBlogHtmlView class methodsFor: 'testing' stamp: 'lr 1/15/2007 21:05'!
isAbstract
	^ false! !

!PBBlogHtmlView class methodsFor: 'testing' stamp: 'lr 1/19/2007 19:13'!
isValidIn: aContext
	^ (super isValidIn: aContext) and: [ aContext structure isBlog ]! !

!PBBlogHtmlView methodsFor: 'accessing-dynamic' stamp: 'lr 2/5/2007 19:27'!
batcher
	^ batcher ifNil: [ batcher := WABatchedList new items: self posts; batchSize: 5 ]! !

!PBBlogHtmlView methodsFor: 'accessing-dynamic' stamp: 'lr 2/5/2007 19:25'!
children
	^ Array with: self batcher! !

!PBBlogHtmlView methodsFor: 'accessing' stamp: 'lr 11/6/2007 18:49'!
posts
	"Answer a default collection of posts."
	
	^ posts ifNil: [ posts := (self blog allPostsIn: self context) reversed ]! !

!PBBlogHtmlView methodsFor: 'accessing' stamp: 'lr 11/6/2007 18:52'!
posts: aCollection
	"Display aCollection of posts in the receiver, presumeably this is a subset of the currently available posts."
	
	posts := aCollection asSortedCollection: [ :a :b | a publication > b publication ].
	batcher := nil! !

!PBBlogHtmlView methodsFor: 'rendering' stamp: 'lr 2/5/2007 19:30'!
renderBatcherOn: html
	(self batcher isOnFirstPage and: [ self batcher isOnLastPage ])
		ifFalse: [ html div class: 'batcher'; with: self batcher ]! !

!PBBlogHtmlView methodsFor: 'rendering' stamp: 'lr 2/5/2007 20:05'!
renderContentOn: html
	super renderContentOn: html.
	self renderPosts: self batcher batch on: html.
	self renderBatcherOn: html.
	self renderRssOn: html! !

!PBHtmlView class methodsFor: 'testing' stamp: 'lr 2/5/2007 19:55'!
isAbstract
	^ true! !

!PBHtmlView methodsFor: 'accessing' stamp: 'lr 2/5/2007 19:35'!
blog
	^ blog ifNil: [ blog := self find: PBBlog ]! !

!PBHtmlView methodsFor: 'actions' stamp: 'lr 11/6/2007 18:56'!
filter: aString
	| newContext |
	newContext := self context structure: self blog.
	newContext command viewComponent posts: (self posts
		select: [ :each | each tags includes: aString ]).
	self context: newContext! !

!PBHtmlView methodsFor: 'rendering-meta' stamp: 'lr 3/9/2007 22:05'!
renderAuthor: anEntry on: html
	anEntry author ifNil: [ ^ self ].
	html span
		class: 'author';
		with: 'by ' , anEntry author.
	html text: ' '! !

!PBHtmlView methodsFor: 'rendering-meta' stamp: 'lr 9/27/2007 10:28'!
renderComment: anEntry on: html
	| comments |
	self context structure isBlog ifFalse: [ ^ self ].
	comments := anEntry allCommentsIn: self context.
	html anchor
		class: 'comment';
		goto: (self context
			structure: (self context structure isBlog
				ifTrue: [ anEntry ]
				ifFalse: [ anEntry parent ]));
		with: (comments isEmpty ifTrue: [ '' ] ifFalse: [ comments size printString ]) ,
			' comment' , (comments size > 1 ifTrue: [ 's' ] ifFalse: [ '' ]).
	html text: ' '! !

!PBHtmlView methodsFor: 'rendering-meta' stamp: 'lr 4/5/2007 17:59'!
renderLink: anEntry on: html
	html anchor
		class: 'link';
		url: (anEntry isPost
			ifTrue: [ (self context structure: anEntry) url ]
			ifFalse: [
				(self context
					structure: (anEntry parents reverse
						detect: [ :each | each isPost ]))
					url fragment: anEntry uuid ]);
		with: 'link'.
	html text: ' '! !

!PBHtmlView methodsFor: 'rendering' stamp: 'lr 3/9/2007 22:06'!
renderMeta: anEntry on: html
	html div class: 'meta'; with: [
		html text: 'Posted '.
		self renderAuthor: anEntry on: html.
		self renderPublication: anEntry on: html.
		self renderTags: anEntry on: html.
		self renderComment: anEntry on: html.
		self renderLink: anEntry on: html ]! !

!PBHtmlView methodsFor: 'rendering' stamp: 'cdlm 11/19/2007 23:31'!
renderPost: aPost on: html
	html div
		class: 'post';
		with: [
			html anchor name: aPost uuid.
			html heading level: 1; with: aPost title.
			self render: aPost on: html.
			self renderMeta: aPost on: html ]! !

!PBHtmlView methodsFor: 'rendering' stamp: 'cdlm 11/19/2007 23:30'!
renderPosts: aCollection on: html
	html div class: 'posts'; with: [
		aCollection do: [ :each | self renderPost: each on: html ] ]! !

!PBHtmlView methodsFor: 'rendering-meta' stamp: 'lr 3/19/2007 20:12'!
renderPublication: anEntry on: html
	anEntry publication ifNil: [ ^ self ].
	html span
		class: 'publication';
		with: 'at ' , anEntry publication date printString ,
			', ' , anEntry publication time printMinutes.
	html text: ' '! !

!PBHtmlView methodsFor: 'rendering' stamp: 'lr 2/12/2007 19:07'!
renderRssOn: html
	html div class: 'subscribe'; with: [
		html anchor
			url: (self context
				structure: self blog
				view: PBEntriesRssView)
					url;
			with: 'Entries (RSS)'.
		html text: ' and '.
		html anchor
			url: (self context
				structure: self blog
				view: PBCommentsRssView)
					url;
			with: 'Comments (RSS)' ]! !

!PBHtmlView methodsFor: 'rendering-meta' stamp: 'lr 11/6/2007 18:55'!
renderTags: anEntry on: html
	anEntry isPost ifFalse: [ ^ self ].
	anEntry tags isEmpty ifTrue: [ ^ self ].
	html span class: 'tags'; with: [
		html text: 'with tags '.
		anEntry tags
			do: [ :each |
				html anchor
					callback: [ self filter: each ];
					with: each ]
			separatedBy: [ html text: ', ' ] ].
	html text: ' '! !

!PBHtmlView methodsFor: 'updating' stamp: 'lr 2/6/2007 18:07'!
updateRoot: aHtmlRoot
	super updateRoot: aHtmlRoot.
	aHtmlRoot rss
		title: self blog feedTitle;
		url: (self context
			structure: self blog
			view: PBEntriesRssView)
				url! !

PBHtmlView subclass: #PBPostHtmlView
	instanceVariableNames: 'post comment command component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

!PBPostHtmlView class methodsFor: 'testing' stamp: 'lr 1/29/2007 13:37'!
isAbstract
	^ false! !

!PBPostHtmlView class methodsFor: 'testing' stamp: 'lr 1/29/2007 13:37'!
isValidIn: aContext
	^ (super isValidIn: aContext) and: [ aContext structure isPost ]! !

!PBPostHtmlView methodsFor: 'private' stamp: 'lr 2/12/2007 19:07'!
buildCommand
	^ (self context
		structure: self comment
		command: self comment editCommandClass new)
			command! !

!PBPostHtmlView methodsFor: 'private' stamp: 'lr 2/20/2007 15:15'!
buildComment
	^ PBComment new
		title: self context structure title;
		yourself! !

!PBPostHtmlView methodsFor: 'private' stamp: 'lr 2/9/2007 01:23'!
buildComponent
	^ (self buildDescription asComponentOn: self command)
		onAnswer: [ :result | self execute: result ];
		addValidatedForm;
		yourself! !

!PBPostHtmlView methodsFor: 'private' stamp: 'lr 5/22/2007 22:48'!
buildDescription
	^ self command description select: [ :each |
		each propertyAt: #public ifAbsent: [ false ] ]! !

!PBPostHtmlView methodsFor: 'accessing' stamp: 'lr 1/29/2007 13:57'!
children
	^ Array with: self component! !

!PBPostHtmlView methodsFor: 'accessing' stamp: 'lr 1/29/2007 14:56'!
command
	^ command ifNil: [ command := self buildCommand ]! !

!PBPostHtmlView methodsFor: 'accessing' stamp: 'lr 1/29/2007 14:57'!
comment
	^ comment ifNil: [ comment := self buildComment ]! !

!PBPostHtmlView methodsFor: 'accessing' stamp: 'lr 1/29/2007 15:11'!
comments
	^ self context structure allCommentsIn: self context! !

!PBPostHtmlView methodsFor: 'accessing' stamp: 'lr 1/29/2007 15:04'!
component
	^ component ifNil: [ component := self buildComponent]! !

!PBPostHtmlView methodsFor: 'private' stamp: 'lr 4/5/2007 17:59'!
execute: anEditCommand
	| addCommand |
	comment := component := command := nil.
	anEditCommand ifNil: [ ^ self ].
	addCommand := PRAddCommand new.
	self context command: addCommand.
	addCommand
		name: (addCommand
			uniqueName: 'comment'
			in: self context structure);
		type: PBComment;
		beUnchecked;
		execute.
	self context
		structure: addCommand answer structure
		command: anEditCommand.
	anEditCommand
		beUnchecked;
		execute! !

!PBPostHtmlView methodsFor: 'testing' stamp: 'lr 2/12/2007 19:07'!
isCommentEnabled
	^ self post publication notNil and: [ self post publication + self blog commentTimeout >= TimeStamp now ]! !

!PBPostHtmlView methodsFor: 'accessing' stamp: 'lr 2/6/2007 19:29'!
post
	^ post ifNil: [ post := self find: PBPost ]! !

!PBPostHtmlView methodsFor: 'rendering' stamp: 'lr 4/24/2007 22:26'!
renderComments: aCollection on: html
	aCollection do: [ :each |
		html div class: 'comment'; with: [
			html anchor name: each uuid.
			self render: each on: html.
			self renderMeta: each on: html ] ]! !

!PBPostHtmlView methodsFor: 'rendering' stamp: 'lr 3/19/2007 20:08'!
renderContentOn: html
	self render: self post on: html.
	self renderMeta: self post on: html.
	html div class: 'comments'; with: [
		self renderComments: self comments on: html.
		self isCommentEnabled
			ifTrue: [ self renderLeaveCommentOn: html ] ].
	self renderRssOn: html! !

!PBPostHtmlView methodsFor: 'rendering' stamp: 'lr 3/19/2007 20:07'!
renderLeaveCommentOn: html
	html div class: 'leavecomment'; with: [
		html heading level: 2; with: 'Leave a comment'.
		html render: self component ]! !
